org.mariadb.jdbc

## Class MariaDbResultSetMetaData

- java.lang.Object
- - org.mariadb.jdbc.MariaDbResultSetMetaData

All Implemented Interfaces:
  ResultSetMetaData, Wrapper

    public class MariaDbResultSetMetaData
    extends Object
    implements ResultSetMetaData

### Field Summary

### Fields inherited from interface java.sql.ResultSetMetaData

`columnNoNulls, columnNullable, columnNullableUnknown`

### Constructor Summary

Constructors
Constructor and Description
`MariaDbResultSetMetaData(ColumnInformation[] fieldPackets, Options options, boolean forceAlias)` Constructor.

### Method Summary

All Methods Instance Methods Concrete Methods
`String` `getCatalogName(int column)` Get the designated column's table's schema.
`String` `getColumnClassName(int column)` Returns the fully-qualified name of the Java class whose instances are manufactured if the method `ResultSet.getObject` is called to retrieve a value from the column.
`int` `getColumnCount()` Returns the number of columns in this `ResultSet` object.
`int` `getColumnDisplaySize(int column)` Indicates the designated column's normal maximum width in characters.
`String` `getColumnLabel(int column)` Gets the designated column's suggested title for use in printouts and displays.
`String` `getColumnName(int column)` Get the designated column's name.
`int` `getColumnType(int column)` Retrieves the designated column's SQL type.
`String` `getColumnTypeName(int column)` Retrieves the designated column's database-specific type name.
`int` `getPrecision(int column)` Get the designated column's specified column size.
`int` `getScale(int column)` Gets the designated column's number of digits to right of the decimal point. 0 is returned for data types where the scale is not applicable.
`String` `getSchemaName(int column)`
`String` `getTableName(int column)` Gets the designated column's table name.
`boolean` `isAutoIncrement(int column)` Indicates whether the designated column is automatically numbered.
`boolean` `isCaseSensitive(int column)` Indicates whether a column's case matters.
`boolean` `isCurrency(int column)` Indicates whether the designated column is a cash value.
`boolean` `isDefinitelyWritable(int column)` Indicates whether a write on the designated column will definitely succeed.
`int` `isNullable(int column)` Indicates the nullability of values in the designated column.
`boolean` `isReadOnly(int column)` Indicates whether the designated column is definitely not writable.
`boolean` `isSearchable(int column)` Indicates whether the designated column can be used in a where clause.
`boolean` `isSigned(int column)` Indicates whether values in the designated column are signed numbers.
`boolean` `isWrapperFor(Class<?> iface)` Returns true if this either implements the interface argument or is directly or indirectly a wrapper for an object that does.
`boolean` `isWritable(int column)` Indicates whether it is possible for a write on the designated column to succeed.
`<T> T` `unwrap(Class<T> iface)` Returns an object that implements the given interface to allow access to non-standard methods, or standard methods not exposed by the proxy.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### MariaDbResultSetMetaData

    public MariaDbResultSetMetaData(ColumnInformation[] fieldPackets,
                                    Options options,
                                    boolean forceAlias)

Constructor.

Parameters:
  `fieldPackets` - column informations
  `options` - connection options
  `forceAlias` - force table and column name alias as original data

### Method Detail

#### getColumnCount

    public int getColumnCount()

Returns the number of columns in this `ResultSet` object.

Specified by:
  `getColumnCount` in interface `ResultSetMetaData`
Returns:
  the number of columns

#### isAutoIncrement

    public boolean isAutoIncrement(int column)
                            throws SQLException

Indicates whether the designated column is automatically numbered.

Specified by:
  `isAutoIncrement` in interface `ResultSetMetaData`
Parameters:
  `column` - the first column is 1, the second is 2, ...
Returns:
  `true` if so; `false` otherwise
Throws:
  `SQLException` - if a database access error occurs

#### isCaseSensitive

    public boolean isCaseSensitive(int column)
                            throws SQLException

Indicates whether a column's case matters.

Specified by:
  `isCaseSensitive` in interface `ResultSetMetaData`
Parameters:
  `column` - the first column is 1, the second is 2, ...
Returns:
  `true` if so; `false` otherwise
Throws:
  `SQLException` - if a database access error occurs

#### isSearchable

    public boolean isSearchable(int column)

Indicates whether the designated column can be used in a where clause.

Specified by:
  `isSearchable` in interface `ResultSetMetaData`
Parameters:
  `column` - the first column is 1, the second is 2, ...
Returns:
  `true` if so; `false` otherwise

#### isCurrency

    public boolean isCurrency(int column)

Indicates whether the designated column is a cash value.

Specified by:
  `isCurrency` in interface `ResultSetMetaData`
Parameters:
  `column` - the first column is 1, the second is 2, ...
Returns:
  `true` if so; `false` otherwise

#### isNullable

    public int isNullable(int column)
                   throws SQLException

Indicates the nullability of values in the designated column.

Specified by:
  `isNullable` in interface `ResultSetMetaData`
Parameters:
  `column` - the first column is 1, the second is 2, ...
Returns:
  the nullability status of the given column; one of `columnNoNulls`, `columnNullable` or `columnNullableUnknown`
Throws:
  `SQLException` - if a database access error occurs

#### isSigned

    public boolean isSigned(int column)
                     throws SQLException

Indicates whether values in the designated column are signed numbers.

Specified by:
  `isSigned` in interface `ResultSetMetaData`
Parameters:
  `column` - the first column is 1, the second is 2, ...
Returns:
  `true` if so; `false` otherwise
Throws:
  `SQLException` - if a database access error occurs

#### getColumnDisplaySize

    public int getColumnDisplaySize(int column)
                             throws SQLException

Indicates the designated column's normal maximum width in characters.

Specified by:
  `getColumnDisplaySize` in interface `ResultSetMetaData`
Parameters:
  `column` - the first column is 1, the second is 2, ...
Returns:
  the normal maximum number of characters allowed as the width of the designated column
Throws:
  `SQLException` - if a database access error occurs

#### getColumnLabel

    public String getColumnLabel(int column)
                          throws SQLException

Gets the designated column's suggested title for use in printouts and displays. The suggested title is usually specified by the SQL `AS` clause. If a SQL `AS` is not specified, the value returned from `getColumnLabel` will be the same as the value returned by the `getColumnName` method.

Specified by:
  `getColumnLabel` in interface `ResultSetMetaData`
Parameters:
  `column` - the first column is 1, the second is 2, ...
Returns:
  the suggested column title
Throws:
  `SQLException` - if a database access error occurs

#### getColumnName

    public String getColumnName(int column)
                         throws SQLException

Get the designated column's name.

Specified by:
  `getColumnName` in interface `ResultSetMetaData`
Parameters:
  `column` - the first column is 1, the second is 2, ...
Returns:
  column name
Throws:
  `SQLException` - if a database access error occurs

#### getCatalogName

    public String getCatalogName(int column)
                          throws SQLException

Get the designated column's table's schema.

Specified by:
  `getCatalogName` in interface `ResultSetMetaData`
Parameters:
  `column` - the first column is 1, the second is 2, ...
Returns:
  schema name or "" if not applicable
Throws:
  `SQLException` - if a database access error occurs

#### getPrecision

    public int getPrecision(int column)
                     throws SQLException

Get the designated column's specified column size. For numeric data, this is the maximum precision. For character data, this is the length in characters. For datetime datatypes, this is the length in characters of the String representation (assuming the maximum allowed precision of the fractional seconds component). For binary data, this is the length in bytes. For the ROWID datatype, this is the length in bytes. 0 is returned for data types where the column size is not applicable.

Specified by:
  `getPrecision` in interface `ResultSetMetaData`
Parameters:
  `column` - the first column is 1, the second is 2, ...
Returns:
  precision
Throws:
  `SQLException` - if a database access error occurs

#### getScale

    public int getScale(int column)
                 throws SQLException

Gets the designated column's number of digits to right of the decimal point. 0 is returned for data types where the scale is not applicable.

Specified by:
  `getScale` in interface `ResultSetMetaData`
Parameters:
  `column` - the first column is 1, the second is 2, ...
Returns:
  scale
Throws:
  `SQLException` - if a database access error occurs

#### getTableName

    public String getTableName(int column)
                        throws SQLException

Gets the designated column's table name.

Specified by:
  `getTableName` in interface `ResultSetMetaData`
Parameters:
  `column` - the first column is 1, the second is 2, ...
Returns:
  table name or "" if not applicable
Throws:
  `SQLException` - if a database access error occurs

#### getSchemaName

    public String getSchemaName(int column)

Specified by:
  `getSchemaName` in interface `ResultSetMetaData`

#### getColumnType

    public int getColumnType(int column)
                      throws SQLException

Retrieves the designated column's SQL type.

Specified by:
  `getColumnType` in interface `ResultSetMetaData`
Parameters:
  `column` - the first column is 1, the second is 2, ...
Returns:
  SQL type from java.sql.Types
Throws:
  `SQLException` - if a database access error occurs
See Also:
  `Types`

#### getColumnTypeName

    public String getColumnTypeName(int column)
                             throws SQLException

Retrieves the designated column's database-specific type name.

Specified by:
  `getColumnTypeName` in interface `ResultSetMetaData`
Parameters:
  `column` - the first column is 1, the second is 2, ...
Returns:
  type name used by the database. If the column type is a user-defined type, then a fully-qualified type name is returned.
Throws:
  `SQLException` - if a database access error occurs

#### isReadOnly

    public boolean isReadOnly(int column)

Indicates whether the designated column is definitely not writable.

Specified by:
  `isReadOnly` in interface `ResultSetMetaData`
Parameters:
  `column` - the first column is 1, the second is 2, ...
Returns:
  `true` if so; `false` otherwise

#### isWritable

    public boolean isWritable(int column)

Indicates whether it is possible for a write on the designated column to succeed.

Specified by:
  `isWritable` in interface `ResultSetMetaData`
Parameters:
  `column` - the first column is 1, the second is 2, ...
Returns:
  `true` if so; `false` otherwise

#### isDefinitelyWritable

    public boolean isDefinitelyWritable(int column)

Indicates whether a write on the designated column will definitely succeed.

Specified by:
  `isDefinitelyWritable` in interface `ResultSetMetaData`
Parameters:
  `column` - the first column is 1, the second is 2, ...
Returns:
  `true` if so; `false` otherwise

#### getColumnClassName

    public String getColumnClassName(int column)
                              throws SQLException

Returns the fully-qualified name of the Java class whose instances are manufactured if the method `ResultSet.getObject` is called to retrieve a value from the column. `ResultSet.getObject` may return a subclass of the class returned by this method.

Specified by:
  `getColumnClassName` in interface `ResultSetMetaData`
Parameters:
  `column` - the first column is 1, the second is 2, ...
Returns:
  the fully-qualified name of the class in the Java programming language that would be used by the method `ResultSet.getObject` to retrieve the value in the specified column. This is the class name used for custom mapping.
Throws:
  `SQLException` - if a database access error occurs

#### unwrap

    public <T> T unwrap(Class<T> iface)
                 throws SQLException

Returns an object that implements the given interface to allow access to non-standard methods, or standard methods not exposed by the proxy.
If the receiver implements the interface then the result is the receiver or a proxy for the receiver. If the receiver is a wrapper and the wrapped object implements the interface then the result is the wrapped object or a proxy for the wrapped object. Otherwise return the the result of calling `unwrap` recursively on the wrapped object or a proxy for that result. If the receiver is not a wrapper and does not implement the interface, then an `SQLException` is thrown.

Specified by:
  `unwrap` in interface `Wrapper`
Parameters:
  `iface` - A Class defining an interface that the result must implement.
Returns:
  an object that implements the interface. May be a proxy for the actual implementing object.
Throws:
  `SQLException` - If no object found that implements the interface

#### isWrapperFor

    public boolean isWrapperFor(Class<?> iface)
                         throws SQLException

Returns true if this either implements the interface argument or is directly or indirectly a wrapper for an object that does. Returns false otherwise. If this implements the interface then return true, else if this is a wrapper then return the result of recursively calling `isWrapperFor` on the wrapped object. If this does not implement the interface and is not a wrapper, return false. This method should be implemented as a low-cost operation compared to `unwrap` so that callers can use this method to avoid expensive `unwrap` calls that may fail. If this method returns true then calling `unwrap` with the same argument should succeed.

Specified by:
  `isWrapperFor` in interface `Wrapper`
Parameters:
  `iface` - a Class defining an interface.
Returns:
  true if this implements the interface or directly or indirectly wraps an object that does.
Throws:
  `SQLException` - if an error occurs while determining whether this is a wrapper for an object with the given interface.